<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG3 del grupo M3<br>
			Titulo: TG3. Implementar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li><a href="#4">4. Implementación del prototipo con tecnología A</a></li>
			<li><a href="#5">5. Implementación del prototipo con tecnología B</a></li>
			<li><a href="#6">6. Comparacion de los prototipos</a></li>
			<li><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>Grupo: M3</p>
			<p>
				Integrantes del grupo: Adina Murg (Product Owner), Arman Ananian Lalayan (Developer), 
				Adrián Valledor Pérez (Developer), Diego Lobo Bellón (Developer), Diego Gerardo Estalrich Cuellar (Developer)
			</p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>URL Proyecto TG3 del grupo M3:
				<a href="https://gitlab.com/dte2020/m3/tg3/">URL proyecto M3</a>.</p>
			<h3>1.3 Burndown chart</h3>
			<p>Diagrama Burndown final del Sprint TG3:</p>
			<img src="burndownTG3.jpg">
			<h3>1.4 Presentacion del trabajo</h3>
			<p>Enlace al archivo de la presentación:</p>
			<a href="tg3.pptx">Presentacion con diapositivas del trabajo TG3</a></p>
		</section>
		<section id="2">
			<h2>2. Requisitos de los prototipos a implementar</h2>
			<p>El objetivo del proyecto es comparar la implementación de dos prototipos utilizando dos tecnologías diferentes de Web Scrapping,
			Puppeteer y Cheerio. Aunque ambas tecnologías son utilizadas para extraer información de la web, tienen funciones concretas 
			y son utilizadas con distintos fines específicos.
			Decidimos emplear dichas herramientas con prototipos de extracción de texto (titulares)y de imágenes.
			Dos entornos diferentes para ver el comportamiento de cada tecnología y cómo se adaptan a él.
			Con ésto comprobaremos las diferencias entre líneas de código, facilidad de aprendizaje, etc.
			</p>
			
			
			<table>
				<tr>
					<th>Requisito</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>Requisito Funcional 01</td>
					<td>El lenguaje a emplear será JavaScript </td>
				</tr>
				<tr>
					<td>Requisito Funcional 02</td>
					<td>Realiza el setup para el scrapeo web</td>
				</tr>
				<tr>
					<td>Requisito Funcional 03</td>
					<td>La herramienta debe la extracción de imágenes.</td>
				</tr>
				<tr>
					<td>Requisito Funcional 04</td>
					<td>La herramienta debe la extracción de texto.</td>
				</tr>
				<tr>
					<td>Requisito Funcional 05</td>
					<td>La herramienta actúa sobre el código HTML de una página web</td>
				</tr>
				<tr>
					<td>Requisito Funcional 06</td>
					<td>La herramienta se podrá ejecutar desde una terminal</td>
				</tr>
				<tr>
					<td>Requisito Funcional 07</td>
					<td>La herramienta deberá permitir la instalacción de los paquetes desde una terminal</td>
			    </tr>
				<tr>
					<td>Requisito Funcional 08</td>
					<td>La herramienta permitirá su uso junto con extensiones adicionales</td>
				</tr>	
				<tr>
					<td>Requisito No Funcional 09</td>
					<td>La herramienta se deberá ejecutar desde un editor externo como Visual Studio</td>
				</tr>
				<tr>	
					<td>Requisito No Funcional 10</td>
					<td>La visualización del resultado se hará por consola</td>
				</tr>
				<tr>	
					<td>Requisito No Funcional 11</td>
					<td>El tiempo de ejecución no podrá ser superior a los 30.000 ms (0.5 minuto)</td>
				</tr>
			</table>

		</section>
		<section id="3">
			<h2>3. Criterios de comparacion de los prototipos</h2>
			
			<h3>3.1 Criterio 1: Líneas de código</h3>
			
			<ul>
				<li>Nombre del criterio: Líneas de código.</li>
				<li>Descripcion: Cantidad de líneas de código necesarias para desarrollar el prototipo.</li>
				<li>Tipo de valor: Numérico.</li>
			</ul>
			<h3>3.2 Criterio 2: Tiempo necesario para la implementación.</h3>
				<ul>
					<li>Nombre del criterio: Tiempo de implementación.</li>
					<li>Descripcion: Estimación aproximada del tiempo empleado en el diseño de cada prototipo.</li>
					<li>Tipo de valor: Numérico (Horas).</li>
				</ul>
			<h3>3.3 Criterio 3: Dificultad del proceso.</h3>
				<ul>
					<li>Nombre del criterio: Dificultad del proceso.</li>
					<li>Descripcion: Dificultad del proceso de realización del prototipo valorado en una escala de 1 a 5.</li>
					<li>Tipo de valor: Numérico.</li>
				</ul>
			<h3>3.4 Criterio 4: Claridad del resultado.</h3>
				<ul>
					<li>Nombre del criterio: Claridad del resultado.</li>
					<li>Descripcion: Facilidad con la que se muestra el resultado obtenido en pantalla.</li>
					<li>Tipo de valor: Texto libre.</li>
				</ul>
			<h3>3.5 Criterio 5: Ejecución.</h3>
				<ul>
					<li>Nombre del criterio: Ejecución.</li>
					<li>Descripcion: Dificultad a la hora de ejecutar el prototipo para obtener resultados.</li>
					<li>Tipo de valor: Texto libre.</li>
				</ul>
			<h3>3.6 Criterio 6: Adaptabilidad</h3>
				<ul>
					<li>Nombre del criterio: Adaptabilidad.</li>
					<li>Descripcion: Facilidad para adaptar los prototipos a nuevas necesidades o usos.</li>
					<li>Tipo de valor: Texto libre.</li>
				</ul>
			<h3>3.7 Criterio 7: Documentación.</h3>
				<ul>
					<li>Nombre del criterio: Documentación.</li>
					<li>Descripcion: Valoración de si la documentación obtenida ha sido suficiente y eficaz.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.8 Criterio 8: Tiempo de ejecución.</h3>
				<ul>
					<li>Nombre del criterio: Tiempo de ejecución.</li>
					<li>Descripcion: Estimación aproximada del tiempo de ejecución de cada prototipo.</li>
					<li>Tipo de valor: Numérico (Segundos)</li>
				</ul>
			<h3>3.9 Criterio 9: Tamaño.</h3>
				<ul>
					<li>Nombre del criterio: Tamaño.</li>
					<li>Descripcion: Tamaño que ocupa el prototipo en disco.</li>
					<li>Tipo de valor: Numérico (MB)</li>
				</ul>
			<h3>3.10 Criterio 10: Herramientas adicionales/complementos.</h3>
				<ul>
					<li>Nombre del criterio: Herramientas adicionales/complementos.</li>
					<li>Descripcion: Indicar si es necesario o no la instalación adicional de alguna herramienta o complemento
					para desarrollar los prototipos, así como el nombre de la misma.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.11 Criterio 11: Capacidades.</h3>
				<ul>
					<li>Nombre del criterio: Capacidades.</li>
					<li>Descripcion: Mencionar si las herramientas tienen alguna funcionalidad a destacar o falta de ella.</li>
					<li>Tipo de valor: Texto libre.</li>
				</ul>
		</section>

		<section id="4">
			<h2>4. Implementación del prototipo con tecnología Cheerio</h2>
			<p>A continuación, incluimos un enlace desde el que poder descargar los archivos necesarios
			para implementar nuestro prototipo con Cheerio junto con un pequeño documento explicativo.</p>
			<p>Enlace al prototipo:
				<a
					href="https://gitlab.com/dte2020/m3/tg3/-/tree/master/prototipo-A/">Prototipo Cheerio</a>.
			</p>
			<p>En este enlace encontraremos los siguientes archivos:</p>

			<p>1. Un documento que sirve de guía para realizar de forma autónoma este prototipo, comprender su funcionamiento, para la extracción de texto e imagen.</p>
			
			<p>2. Una carpeta "node_modules", que se genera automáticamente durante el proceso de instalación
			y contiene las librerias necesarias para su funcionamiento.</p>
			
			<p>3. Un archivo "package-lock.json", que también se autogenera e incluye enlaces necesarios para
			su funcionamiento.</p>
			
			<p>4. Otro archivo "package.json" que actúa como base y controla la versión de desarrollo.</p>
			
			<p>5. Por último, el archivo "index.js" que contiene todo el código epecífico para realizar el ejemplo de scraping sobre la página que utilizamos de ejemplo.</p>
		</section>

		<section id="5">
			<h2>5. Implementación del prototipo con Puppeteer</h2>
			
			<p>Enlace a gitlab con todo lo necesario para implementar y probar Puppeteer:
				<a
					href="https://gitlab.com/dte2020/m3/tg3/-/tree/master/prototipo-B">Gitlab Puppeteer</a>.
			</p>
			
			<p>En este enlace encontraremos dos archivos:</p>
			
			<p>1.Una guía para la instalación e implementación de Puppeteer:
				Aquí se explica en sencillos pasos como instalar todo lo necesario para poder trabajar con Puppeteer y poder implementar correctamente el ejemplo básico de extracción de imágenes y obtención de titulares. Dentro se muentran los pasos a seguir, el código a implmentar además de una explicación para comprender cómo modificarlo y adaptarlo pra otras pruebas además de capturas con los resultados a obtener.
Recomendamos seguir estos pasos y utilizar el archivo anterior para copiar el código a la hora de realizarlo
cuando lo pida este documento para evitar errores y de esta manera visualizar un resultado correcto.
</p>

			<p>2.Un archivo JavaScript con el código de la implementación de Puppeteer para la obtención de una imagen/screenshot de una página web, denominado 'Package.js'.	
			</p>

			<p>3. Otro archivo JavaScript denominado 'obtenciontitulares.js' con el que podremos comparar de una manera más exacta Puppeteer con Cheerio, el prototipo anterior.
</p>
<p>4. Una carpeta "node_modules", que se genera automáticamente durante el proceso de instalación
			y contiene las librerias necesarias para su funcionamiento.
			También incluye Chromium, obligatorio para que Puppeteer funcione.</p>
			
<p>5. Un archivo "package-lock.json", autogenerado con enlaces necesarios para
			su funcionamiento.</p>
			
<p>6. Otro archivo "package.json" que actúa como base y controla la versión de desarrollo.</p>	
		</section>

		<section id="6">
			<h2>6. Comparacion de los prototipos</h2>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Cheerio</th>
					<th>Puppeteer</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>Criterio 1: Líneas de código</td>
					<td>Prototipo extraccion imagen + titular 22</td>
					<td>Prototipo extraccion imagen + titular 49 </td>
					<td>Ambos prototipos tienden hacia un número de líneas de código similares, aunque para el prototipo de Puppeteer se separaron los 
						códigos en 2 diferentes y estamos contando de nuevo líneas repetidas (como la llamada a librerías).
					Aún así, podemos asegurar que Cheerio emplea un menor número de líneas de código dado que no precisa de ciertas líneas como las de abrir y cerrar Chromium (ya que no lo usa).</td>
				</tr>
				<tr>
					<td>Criterio 2: Tiempo necesario para la implementación.</td>
					<td>2 horas aprox. </td>
					<td>2 horas aprox.</td>
					<td>Desde que instalamos Node.js hasta que redactamos y ejecutamos el código.
						El tiempo de espera será mayor en Puppeteer (con una ligera diferencia) ya que necesita tiempo
						para cargar la web objetivo de scraping en Chromium (además de unos breves instantes adicionales que requiere su descarga, ya explicada en la guía), mientras que Cheerio no lo necesita, haciéndolo más ágil.
					</td>
				</tr>
				<tr>
					<td> Criterio 3: Dificultad del proceso.</td>
					<td>2 </td>
					<td>2.5 </td>
					<td>No contamos el coste adicional de inspeccionar el código de la página.
						Cheerio es más sencillo ya que el código presenta las dos extracciones frente a Puppeteer.
					</td>
				</tr>


				<tr>
					<td> Criterio 4: Claridad del resultado.</td>
					<td>Presenta mayor calidad respecto al texto, mostrandose de forma más ordenada y sencilla.</td>
					<td>Destaca con la presentación de la imagen, que además nos permite descargarla, con lo que podemos tener una mejor visualización (agrandarla, etc)</td>
					<td> Puppeteer y Cheerio cumplen bien las expectativas, pero cada uno destaca en la sección ya explicada anteriormente.

					</td>
				</tr>
				<tr>
					<td> Criterio 5: Ejecución.</td>
					<td>Sencillo</td>
					<td>Sencillo</td>
					<td> Ambos códigos son sencillos de ejecutar, con pocas líneas de código
						y fácil comprensión, además de poderse ejecutar desde la terminal o editores externos.

					</td>
				</tr>
				<tr>
					<td> Criterio 6: Adaptabilidad</td>
					<td>Complejo</td>
					<td>Complejo</td>
					<td> La complejidad viene dada por el tipo de web objetivo a escrapear.
						Las modificaciones, no sólo en el nombre de la web, si no de los elementos a obtener, deberán
						buscarse en el código html de la página e introducirse en el código, por ejemplo, el nombre de la clase en Puppeteer.
						Esto implica adaptar el formato al tipo de elemento objetivo, ya sea imagen, texto, etc.
					</td>
				</tr>


				<tr>
					<td>Criterio 7: Documentación.</td>
					<td>Si</td>
					<td>Si</td>
					<td> Hay suficiente cantidad de documentación para ambas tecnologías para elaborar y modificar 
						ejemplos básicos para entender el funcionamiento de ambas tecnologías y poder implementarlas correctamente.
					</td>
				</tr>



				<tr>
					<td>Criterio 8: Tiempo de ejecución.
					</td>
					<td>7 </td>
					<td>20</td>
					<td> El tiempo de Cheerio es mucho menor frente a Puppeteer y esto es debido a que 
						Puppeteer debe inicializar el buscador y cargar completamente la página (a veces, incluso, sobrepasando el tiempo límite de 30.000ms)
						antes de permitir la visualización de los resultados.

					</td>
				</tr>

				<tr>
					<td>Criterio 9: Tamaño.
					</td>
					<td>9 </td>
					<td>328</td>
					<td> En el tamaño se incluyen los módulos de node además de los códigos JavaScript.
						Cheerio resulta ser mucho menos pesado, ya que Puppeteer incluye Chromium (dentro de la carpera pupeeteer, con un peso es de 324MB)
						Cheerio cuenta con la librería adicional request.
					</td>
				</tr>
				<tr>
					<td>Criterio 10: Herramientas adicionales/complementos.
					</td>
					<td>Si</td>
					<td>Si</td>
					<td> Cheerio precisa de la librería request.
						Puppeteer necesita Chromium para funcionar.
					</td>
				</tr>
				<tr>
					<td>Criterio 11: Capacidades.
					</td>
					<td>Si</td>
					<td>No</td>
					<td>Cheerio no nos permite realizar capturas de pantalla, además de que la obtención de imágenes es muy costosa y no nos permite 
						descargarla directamente a nuestro ordenador como es el caso de Puppeteer. No presenta problemas para obtener titulares.
						Puppeter no nos plantea ningún problema a la hora de extraer imágenes/capturas ni de obtener el texto de 
						los titulares.
					</td>
				</tr>
			</table>
		</section>

		<section id="7">
			<h2>7. Conclusiones</h2>
			<p>En esta práctica decidimos implementar un prototipo subdivido en dos partes, la primera es la de captación de texto (titulares de periódicos o revistas informativas) y la segunda la de obtención de imágenes. Como se puede comprobar, los métodos de implementación y el entorno de desarrollo son muy similares, ambos precisan de la instalación de la tecnología (ya sea Cheerio o Puppeteer), además de Node.js. Podemos observar en los puntos 4 y 5 que las carpetas y los archivos json son idénticos.</p>
			<p>Puppeteer a diferencia de Cheerio, necesita hacer uso de Chromium, lo que implica un coste de tiempo adicional, ya que hay tiene que abrir el navegador, esperar a que cargue la página y luego cerrarla, lo cual se puede traducir en una demora extra de tiempo, además de ciertos problemas que puede ocasionar si se excede el tiempo asignado de espera.</p>
			<p>No aparece en el código del prototipo (que cuenta con un tiempo máximo de 30.000 ms) pero se puede añadir “await page.setDefaultNavigationTimeout(0);” justo antes de “await page.goto” para, de esta manera, evitar fallos por exceso de tiempo de carga.</p>
			<p>También podemos concluir que ambas tecnologías son fáciles de implementar y de usar, y que entre ellas no hay demasiada diferencia respecto a conocimientos requeridos de codificación, ya que ambos usan aproximadamente las mismas líneas de código, además de la facilidad de compresión de lo que vemos. En este caso en concreto, hay que destacar que Puppeteer es más comprensible que Cheerio, más fácil de interpretar.</p>
			<p>Ejemplo de ello es, en Cheerio -> “$(‘a’, ‘h3.voc-title’).each((index,el)) => {console.log($(el).text());}”
				Frente a Puppeteer -> “let tags = document.getElementsByClassName (‘bullet style_1’)”
				</p>
			<p>Cabe destacar que ambas tecnologías se enfocan a diversas cuestiones, siendo más fácil scrapear determinados elementos con una frente a otra, véase el caso de las imágenes, Puppeteer es más eficiente, preciso y sencillo en su obtención que Cheerio. Por otro lado, respecto a obtener tirulares, los resultados de Cheerio son superiores a los de Puppeteer, que suele tener más problemas para scrapear correctamente texto.</p>
			<p>En cuanto problemas generales, es preciso hacer uso de ‘inspeccionar elemento’ para escrapear correctamente, ya que hay que adaptar el código a cada página web y buscar lo que queremos obtener, a veces siendo esto bastante difícil o imposible. En algunas ocasiones, algunos códigos, como en el caso de Puppeteer, ejemplo -> const title = await page.title(); console.log(title); nos permite obtener el título de las diversas páginas web, el código se adapta a la web, pero este es uno de los pocos casos que esto sucede sin necesidad de inspeccionar la página.</p>
			<p>Ejemplo de ellos es, El País página difícil de scrapear, o la confusión de no seleccionar, por ejemplo, el titular en sí y seleccionar el cuadro de texto, lo cual nos devolvería un error.</p>
			<p>Algunas páginas nos resultaron más fáciles a la hora de scrapear que otras, como por ejemplo marca.es y lalunadealcala.com. Descubrimos que algunas páginas ponen más restricciones que otras a ser escrapeadas y esto se puede observar poniendo en el buscador www.pagina.com/robots.txt. Es notable la comparación entre marca.es y elpais.es de los permisos que nos conceden. Robots txt son un grupo de estándares web de regulación de rastreo web, con instrucciones que especifican que contenido se permite o no rastrear de dicha web. Por tanto, cuantas más restricciones, más complicado el scrapeo.</p>
			<p>Las conclusiones que hemos obtenido tras la realización de las comparaciones de los prototipos es la de que la curva de aprendizaje entre ambas tecnologías es idéntica, según nuestra experiencia, no se requiere más o menos conocimientos para ninguna de las dos, pero, tal y como se ha expuesto anteriormente, cada tecnología es mejor que la otra, por lo que se recomendaría aprender a utilizar ambas tecnologías, y así adaptar el uso de Cheerio o Puppeteer según el objetivo que tengamos a extraer.</p>
<p>
	No podemos decidir si una tecnología es mejor que la otra ya que ambas, además de estar en continuo y pleno desarrollo, cumplen varios requisitos y funciones, con la diferencia de que alguna tecnología es más adecuada que otra, aunque ambas sean capaces de cumplir sus objetivos, como el de obtención de imágenes o de texto-titulares.	
</p>>
	
		</section>

		<p></p>

	</main>

</body>

</html>
